package com.fp.persistence.pbpm.gene;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TBPMGROUPSUSERS*/
@Embeddable
public class TbpmGroupsUsersKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="USERCODE", nullable=false,updatable=false)

/**
* Codigo de usuario
*/
private String usercode;

@Column(name="GROUPCODE", nullable=false,updatable=false)

/**
* Codigo de grupo de usuarios de un bpm
*/
private String groupcode;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania
*/
private Integer companycode;

/**Contructor por defecto*/
public TbpmGroupsUsersKey(){}
/**Contructor de TbpmGroupsUsersKey
@param pUsercode Codigo de usuario
@param pGroupcode Codigo de grupo de usuarios de un bpm
@param pCompanycode Codigo de compania
*/
public TbpmGroupsUsersKey(String pUsercode,String pGroupcode,Integer pCompanycode){
 usercode=pUsercode;
 groupcode=pGroupcode;
 companycode=pCompanycode;
}
/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de groupcode
@return valor de groupcode*/
public String getGroupcode(){
  return groupcode;
}
/**Fija el valor de groupcode
@param pGroupcode nuevo Valor de groupcode*/
public void setGroupcode(String pGroupcode){
  groupcode=pGroupcode;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Implementación de la comparación de TbpmGroupsUsersKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TbpmGroupsUsersKey))return false;
  TbpmGroupsUsersKey that = (TbpmGroupsUsersKey) o;
  if (this.getUsercode() == null || that.getUsercode() == null){
      return false;
  }
  if (! this.getUsercode().equals(that.getUsercode())){
    return false;
  }
  if (this.getGroupcode() == null || that.getGroupcode() == null){
      return false;
  }
  if (! this.getGroupcode().equals(that.getGroupcode())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TbpmGroupsUsersKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getUsercode() == null ? 0 : this.getUsercode().hashCode());
    result = result * 37 + (this.getGroupcode() == null ? 0 : this.getGroupcode().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
